//+------------------------------------------------------------------+
//|       Experimental Expert Advisor "Chuvashov's Fork"       Vilka_Ch_MTC_v2.mq4 |
//|         for opening BUY and SELL positions             2010,author,Gkov |
//|     and drawing StopLoss in 3 stages            genkov@bk.ru |
//+------------------------------------------------------------------+
#property copyright "2010,author,Gkov"
#property link      "http://ForexkovTrade.com"
#property link      "http://Fxkom.narod.ru"
#property link      "http://forexparter.ucoz.ru/"
#property link      "http://Animatyc.narod.ru"                 
#property link      "genkov@bk.ru , kovgd@ya.ru"
//+------------------------------------------------------------------+
extern int N=50;           // number of calculated bars (for H1 N=50).
extern int M= 3;           // initial bar starting with which the fractals are searched in the loop.
int    i,k;                // bar numbers in loops.
int    Vnf3,Vnf2,Vnf1;     // numbers of reference fractals (1st on the right of the downtrend chart).
int    VnfL3,VnfL2,VnfL1;  // numbers of reference fractals (1st on the right of the uptrend chart).
int    VFN,VFNL;           // counter of the found fractals.
int    Md,MdL;             // counters of the number of modifications
double VMF1,VMF2,VMF3;     // intermediate values of the upper fractals on the downtrend.
double VMFL1,VMFL2,VMFL3;  // intermediate values of the lower fractals on the uptrend.
double VlFl_L;             // Min value of the nearest lower fractal on the downtrend
double VlFl_H;             // Max value of the nearest upper fractal on the uptrend
datetime tim1_L;           // Time of the nearest lower fractal following the downtrend 
datetime timL1_H;          // Time of the nearest upper fractal following the uptrend 
datetime tim1,tim2,tim3;   // time for drawing the Chuvashov's Fork lines.
datetime timL1,timL2,timL3;// time for drawing the Chuvashov's Fork lines.
string   Time1,Time2,Time3;   // time for visual control of operators' performance.
string   TimeL1,TimeL2,TimeL3;// time for visual control of operators' performance.
       // for trend lines directed downwards 
double V_down1,            // speeds of falling of the MAIN(1) trend line over 1 bar.
       V_down2,            // speeds of falling of the lateral trend line over 1 bar.
       PricePrL1_1f,       // Price of the projection of the MAIN(1) trend line on the 1st fractal.
       PricePrL1_2f,       // Price of the projection of the MAIN(1) trend line on the 2nd fractal.
       PricePrL1_1b,       // Price of the projection of the MAIN(1) trend line on the 1st current BAR.
       PricePrL2_1f,       // Price of the projection of the Lateral(2) trend line on the 1st fractal.
       PricePrL2_1b,       // Price of the projection of the Lateral(2) trend line on the 1st current BAR.
       TP_Modific_S;
       // for trend lines directed upwards
double V_up1,              // speeds of falling of the MAIN(1) trend line over 1 bar.
       V_up2,              // speeds of falling of the lateral trend line over 1 bar.
       PricePrH1_1f,       // Price of the projection of the MAIN(1) trend line on the 1st fractal.
       PricePrH1_2f,       // Price of the projection of the MAIN(1) trend line on the 2nd fractal.
       PricePrH1_1b,       // Price of the projection of the MAIN(1) trend line on the 1st current BAR.
       PricePrH2_1f,       // Price of the projection of the Lateral(2) trend line on the 1st fractal.
       PricePrH2_1b,       // Price of the projection of the Lateral(2) trend line on the 1st current BAR.
       TP_Modific_B;

extern double Lots=1.0;
extern double SL_B=30;     // StopLoss is calculated upon placing of every given order.
extern double TP_B=35;     // it is advisable to calculate TP_B based on 0.6 of the channel size.
extern double SL_S=30;     // StopLoss is calculated upon placing of every given order.
extern double TP_S=35;     // it is advisable to calculate TP_B based on 0.6 of the channel size.
int Magic;
bool  patternBuy  = false; // values: true "1" or false "0".
bool  patternSell = false; // values: true "1" or false "0".
 //+------------------------------------------------------------------+
  void DelLine()        // Deleting the Sell trend lines and Chuvashov's Fork marks 
   {
   ObjectDelete("Tr_down1");
   ObjectDelete("Tr_down2");
   ObjectDelete("Frak_1");
   ObjectDelete("Frak_2");
   ObjectDelete("Frak_3");
   }
//+------------------------------------------------------------------+
  void DelLineH()        // Deleting the BUY trend lines and Chuvashov's Fork marks 
   {
   ObjectDelete("Tr_up1");
   ObjectDelete("Tr_up2");
   ObjectDelete("Fr_1");
   ObjectDelete("Fr_2");
   ObjectDelete("Fr_3");
   }
//+------------------------------------------------------------------+
  void CreateLine()       // Creating and drawing the Sell trend lines of Chuvashov's Fork 
   {
   ObjectCreate("Tr_down1",OBJ_TREND,0,tim3,VMF3,tim2,VMF2);
   ObjectSet("Tr_down1",OBJPROP_COLOR,Yellow);
   ObjectSet("Tr_down1",OBJPROP_WIDTH,1);  // in a thin line and 
   ObjectSet("Tr_down1",OBJPROP_STYLE,STYLE_DOT);// dotted line
   ObjectCreate("Tr_down2",OBJ_TREND,0,tim2,VMF2,tim1,VMF1);
   ObjectSet("Tr_down2",OBJPROP_COLOR,Aqua);
   ObjectSet("Tr_down2",OBJPROP_WIDTH,1);  // in a thin line and 
   ObjectSet("Tr_down2",OBJPROP_STYLE,STYLE_DOT);// dotted line 
   }
//+------------------------------------------------------------------+
  void CreateLineH()       // Creating and drawing the BUY trend lines of Chuvashov's Fork 
   {
   ObjectCreate("Tr_up1",OBJ_TREND,0,timL3,VMFL3,timL2,VMFL2);
   ObjectSet("Tr_up1",OBJPROP_COLOR,Yellow);
   ObjectSet("Tr_up1",OBJPROP_WIDTH,1);  // in a thin line and 
   ObjectSet("Tr_up1",OBJPROP_STYLE,STYLE_DOT);// dotted line
   ObjectCreate("Tr_up2",OBJ_TREND,0,timL2,VMFL2,timL1,VMFL1);
   ObjectSet("Tr_up2",OBJPROP_COLOR,Aqua);
   ObjectSet("Tr_up2",OBJPROP_WIDTH,1);  // in a thin line and 
   ObjectSet("Tr_up2",OBJPROP_STYLE,STYLE_DOT);// dotted line 
   }
//+------------------------------------------------------------------+
   void CreateArrow()   // Creating and drawing marks for the Sell trend lines of Chuvashov's Fork
    {
    ObjectCreate("Frak_1",OBJ_ARROW, 0, tim1, VMF1+0.001);
    ObjectSet("Frak_1", OBJPROP_COLOR, Yellow); //yellow color
    ObjectSet("Frak_1", OBJPROP_ARROWCODE,217); //217-fractal mark code
    ObjectCreate("Frak_2",OBJ_ARROW, 0, tim2, VMF2+0.001);
    ObjectSet("Frak_2", OBJPROP_COLOR, Yellow); //yellow color
    ObjectSet("Frak_2", OBJPROP_ARROWCODE,217); //217-fractal mark code
    ObjectCreate("Frak_3",OBJ_ARROW, 0, tim3, VMF3+0.001);
    ObjectSet("Frak_3", OBJPROP_COLOR, Yellow); //yellow color
    ObjectSet("Frak_3", OBJPROP_ARROWCODE,217); //217-fractal mark code
    }
//+------------------------------------------------------------------+
   void CreateArrowH()   // Creating and drawing marks for the BUY trend lines of Chuvashov's Fork
    {
    ObjectCreate("Fr_1",OBJ_ARROW, 0, timL1, VMFL1-0.0001);
    ObjectSet("Fr_1", OBJPROP_COLOR, Yellow); //yellow color
    ObjectSet("Fr_1", OBJPROP_ARROWCODE,218); //218-fractal mark code
    ObjectCreate("Fr_2",OBJ_ARROW, 0, timL2, VMFL2-0.0001);
    ObjectSet("Fr_2", OBJPROP_COLOR, Yellow); //yellow color
    ObjectSet("Fr_2", OBJPROP_ARROWCODE,218); //218-fractal mark code
    ObjectCreate("Fr_3",OBJ_ARROW, 0, timL3, VMFL3-0.0001);
    ObjectSet("Fr_3", OBJPROP_COLOR, Yellow); //yellow color
    ObjectSet("Fr_3", OBJPROP_ARROWCODE,218); //218-fractal mark code
    }
//+------------------------------------------------------------------+
 void Op_Buy_Ch()                                  // opening a BUY position
  {
  if(!OrderSend(Symbol(),OP_BUY,Lots,Ask,2,Bid-SL_B*Point,Ask+TP_B*Point," ",Magic,0,DeepSkyBlue))
      { Print("  SELL order opening error  # ",GetLastError()); }
      return(0);
     }
//+------------------------------------------------------------------+
 void Op_Sell_Ch()
  { 
  if(!OrderSend(Symbol(),OP_SELL,Lots,Bid,2,Ask+SL_S*Point,Bid-TP_S*Point," ",Magic,0,Red)) 
      { Print("  SELL order opening error  # ",GetLastError()); }
      return(0);
     }
//+------------------------------------------------------------------+
 void Close_B_Ch()
  {
  if(!OrderClose(OrderTicket(),OrderLots(),Bid,2,Aqua)) // closing 0.1 lot 
      {Print(" Closing order # ",OrderTicket()," Error # ",GetLastError());}
       return(0);
     }
//+------------------------------------------------------------------+
 void Close_S_Ch()
  {
  if(!OrderClose(OrderTicket(),OrderLots(),Ask,2,Aqua)) // closing 0.1 lot 
      {Print(" Closing order # ",OrderTicket()," Error # ",GetLastError());}
      return(0);
     }  
//+==================================================================+
//|   expert start function                                          +
//+------------------------------------------------------------------+
int start()
  {//start
   if(Volume[0]>1) return; //starting to trade at the first tick of the new bar.
    { //Vol-at the first tick  
    int spread=MarketInfo(Symbol(),MODE_SPREAD);
    int StopLevel=MarketInfo(Symbol(),MODE_STOPLEVEL);
    double Ma144_1 = iMA(NULL,0,144,0,MODE_EMA,PRICE_CLOSE,1);
    double Ma144_24 = iMA(NULL,0,144,0,MODE_EMA,PRICE_CLOSE,24);
    double Ma144_48 = iMA(NULL,0,144,0,MODE_EMA,PRICE_CLOSE,48);
    double Med48=(Ma144_1-Ma144_48)/2+Ma144_48; 
    VFNL=0;VMFL3=0;VMFL2=0;VMFL1=0;VFN=0;VMF3=0;VMF2=0;VMF1=0;Md=0;MdL=0;
    tim1=0;tim2=0;tim3=0;timL1=0;timL2=0;timL3=0;patternBuy=false;
    patternSell=false;
// ==================================================================+===== for a position BUY ==
// Loop for searching for the last three consecutive fractals    +
// lying along the DOWNtrend for the Chuvashov's Fork construction        +
// ==================================================================+
   for (i=M;i<=N;i++)
    {//loop
    if(High[i]>High[i+1] && High[i]>High[i+2] && High[i]>High[i-1] && High[i]>High[i-2])
     {
      VFN++; 
      if(VFN==1) { Vnf1=i; VMF1=High[i]; tim1=iTime(NULL,0,i); }
    // --------------------------------------------------------------+
    if(VFN==2) 
	  { VMF2=High[i]; if(VMF2>VMF1) {Vnf2=i; tim2=iTime(NULL,0,i); } }
    // --------------------------------------------------------------+
    if(VFN==3) { VMF3=High[i]; if(VMF3>VMF2) {Vnf3=i; tim3=iTime(NULL,0,i); } }
// ------------------------------------------------------------------+
   if(VFN==3) break; // all three fractals are found, exit the loop.
// ------------------------------------------------------------------+ 
    }                 
   }//-loop 
// ------------------------------------------------------------------+
   if(VMF3>VMF2 && VMF2>VMF1)
    {  
    V_down1=((VMF3-VMF2)/(Vnf3-Vnf2));    
    PricePrL1_1f=VMF2-(Vnf2-Vnf1)*V_down1;
    if(VMF1>PricePrL1_1f) 
     { 
     if(VMF1==VMF2)  V_down2=0; 
     if(VMF1<VMF2)
      { 
      V_down2=((VMF2-VMF1)/(Vnf2-Vnf1)); 
      }   
     PricePrL2_1b=VMF1-Vnf1*V_down2; 
     PricePrL1_1b=VMF2-Vnf1*V_down1; 
     patternBuy = true; 
     DelLine(); CreateLine(); CreateArrow(); // draw marks and lines having deleted the preceding ones 
     }
    }
// ==================================================================+    
//                    Opening BUY positions                           +
// ==================================================================+
   if(OrdersTotal()<1) // we place one (or 2..3..etc.) orders  
    {  //open a position
// ------------------------------------------------------------------+
   if(patternBuy==true)
    {
     // 1st additional condition - price range over the last 25 bars is at least 50 points.
    if((High[iHighest(Symbol(),Period(),MODE_HIGH,25,0)]-Low[iLowest(Symbol(),Period(),MODE_LOW,25,0)])>=50*Point)
     {
    if(Bid<Ma144_1-89*Point && (Ma144_1-Ma144_48)<0)         // Ma144 slope is negative
     {//2nd additional condition 
    if((High[1]>PricePrL2_1b || Close[1]>PricePrL2_1b || 
       (Open[1]<Close[1] && Close[1]>PricePrL2_1b) || 
       Bid>PricePrL2_1b) && Bid<PricePrL2_1b+3*Point) 
     {
      // Calculate StopLoss as the Min price value over the interval from the "0" bar to the bar of the 2nd fractal.
      SL_B=(Bid-Low[iLowest(Symbol(),Period(),MODE_LOW,Vnf2,0)])/Point;
     if(SL_B<StopLevel) SL_B=StopLevel+12; // if SL_B is less than StopLevel
      //  SL_B=200;
      TP_B=120;
     // Print("  OP_BUY Chuvashov's Fork","  VMF1 = ",VMF1," < ",PricePrH1_1f);
      Op_Buy_Ch();
      return;
      }
     }
    }
   }
  }
// ==================================================================+===== for a position SELL ==
// Loop for searching for the last three consecutive fractals    +
// lying along the UPtrend for the Chuvashov's Fork construction        +
// ==================================================================+      
// ==================================================================+
// Loop for searching for the last three lower fractals of the BUY trend for the Chuvashov's fork construction
   for (i=M;i<=N;i++)
    {//loop
    if(Low[i]<Low[i+1] && Low[i]<Low[i+2] && Low[i]<Low[i-1] && Low[i]<Low[i-2])
     { VFNL++; if(VFNL==1) { VMFL1=Low[i]; VnfL1=i; timL1=iTime(NULL,0,i); }
    // ------------------------------------------------------------+
    if(VFNL==2) 
	  { VMFL2=Low[i]; if(VMFL2<VMFL1) { VnfL2=i; timL2=iTime(NULL,0,i); } }
      // ------------------------------------------------------------+
    if(VFNL==3) { VMFL3=Low[i]; if(VMFL3<VMFL2) { VnfL3=i; timL3=iTime(NULL,0,i); } }
     // -------------------------------------------------------------+
    if(VFNL==3) break; // all three fractals are found, exit the loop.
     }
    }
// ==================================================================*
  if(VMFL3<VMFL2 && VMFL2<VMFL1) // if the both trend lines are going UPWARDS - 
   {
   V_up1=(VMFL2-VMFL3)/(VnfL3-VnfL2);  
   PricePrH1_1f=VMFL3+(VnfL3-VnfL1)*V_up1;
   if(VMFL1<=PricePrH1_1f) 
    {
    if(VMFL1==VMFL2) V_up2=0; 
    if(VMFL1>VMFL2)  
     { V_up2=(VMFL1-VMFL2)/(VnfL2-VnfL1); }
     PricePrH2_1b=VMFL1+(VnfL1-1)*V_up2; 
     patternSell = true; 
     DelLineH(); CreateLineH(); CreateArrowH(); 
    }
// ------------------------------------------------------------------+
// Let us define the conditions for placing a SELL order, the price and StopLoss level:
// ------------------------------------------------------------------+
   if(patternSell == true)
    { 
    if((High[iHighest(Symbol(),Period(),MODE_HIGH,25,0)]-Low[iLowest(Symbol(),Period(),MODE_LOW,25,0)])>=50*Point)
     {
     if((Bid>Ma144_1+55*Point && (Ma144_1-Ma144_48)>-5*Point && Med48<Ma144_24))
      {
    if(Open[1]>Close[1] && Close[1]<PricePrH2_1b || Close[1]<PricePrH2_1b || 
      (Bid<PricePrH2_1b && Bid>PricePrH2_1b+50*Point)) 
     {
      patternSell= true; 
// ------------------------------------------------------------------+
     // Set StopLoss as the Min value of the price over the interval from "0" to the bar of the 3rd fractal.
     SL_S=(High[iHighest(Symbol(),Period(),MODE_HIGH,VnfL3,0)]-Bid)/Point;
     if(SL_S<StopLevel) SL_S=StopLevel+12; // if SL_B is less than StopLevel
     // -------------------------------------------------------------+
     // set the TakeProfit value == 300 pip since the SELL order will be 
     // traced by shifting StopLoss along the upper fractals of the downtrend.
     TP_S=300;
// ==================================================================+
   if(OrdersTotal()<2) // we place one (or 2..3..etc.) orders  
    {  //open a position
     // -------------------------------------------------------------+  
     //Print("  OP_SELL Chuvashov's Fork"," ; SL_S= ",SL_S," ; TP_S= ",TP_S);
     Op_Sell_Ch();
     DelLineH(); CreateLineH(); CreateArrowH();
// ------------------------------------------------------------------+
     return;
       }
      }
     }
    }
   }
  }
 }
//+=======================================================================+
//                   proceed to TRACING opened positions            +
//+=======================================================================+
for (i=OrdersTotal()-1; i>=0; i--)        // loop for selection of BUY orders 
   {//loop for selection of positions Buy
  if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {Print("Order selection error = ", GetLastError()); }
   if(OrderType()==OP_BUY )                // if the Buy order is placed
    { //2-type_Buy
//+=======================================================================+
//|  Conditions for closing BUY positions                                     +
//+=======================================================================+
   if(patternSell==true) 
    { 
    Print(" closing the BUY position as the opposite pattern has emerged");
    Close_B_Ch();         // close the position SELL
    return; 
    }
//+=======================================================================+
//   Conditions for Modification of BUY positions                                      +
// ========================================================= 1st stage ===+
// ---- 1st stage ------------------------------------------ 1st stage ---+
   if((Bid-OrderOpenPrice())>SL_B*Point      // if the difference between the price and the opening value is >SL_B
       && OrderStopLoss()<OrderOpenPrice())  // and if StopLoss is lower than the position opening level
    {// modif-1
     OrderModify(OrderTicket(),                // order #. 
     OrderOpenPrice(),                         // opening price. 
     OrderStopLoss()+(SL_B/2)*Point,           // New value of StopLoss.
     OrderTakeProfit()+1*Point,                // New value of TakeProfit.
     0,                                        // Deferred order expiration time.
     Red);                                     // Color of modification marks (dashes).
     return;
    }//-modif-1
// --- end of 1st stage -----------------------------------------------------+
// ---- 2nd stage ------------------------------------------ 2nd stage ---+
   if((Bid-OrderOpenPrice())>SL_B*Point      // if the difference between the price and the position opening value is >SL_B
       && OrderStopLoss()<OrderOpenPrice())  // and if StopLoss is lower than the position opening level
    {// modif-1
     OrderModify(OrderTicket(),                // order #. 
     OrderOpenPrice(),                         // opening price. 
     OrderStopLoss()+(SL_B+StopLevel)*Point,   // New value of StopLoss. 
     OrderTakeProfit()+1*Point,                // New value of TakeProfit.
     0,                                        // Deferred order expiration time.
     Magenta);                                 // Color of modification marks (dashes).
     return;
    }//-modif-1
// --- end of 2nd stage -----------------------------------------------------+
// ---- 3rd stage --------------------------------------- 3rd stage ------+
   if((Bid-OrderOpenPrice())>=(SL_B+SL_B/2)*Point  
       && OrderStopLoss()>=OrderOpenPrice()) 
    {
    for (k=3;k<=24;k++)
     {//loop-
     if(Low[k]<Low[k+1] && Low[k]<Low[k+2] && Low[k]<Low[k-1] && Low[k]<Low[k-2])
      { 
      VlFl_L=Low[k];          
     if(VlFl_L>OrderStopLoss()) 
      {
      tim1_L=iTime(NULL,0,k);  
      OrderModify(OrderTicket(),            // order # 
      OrderOpenPrice(),                     // opening price 
      VlFl_L+2*Point,                       // New value of StopLoss. // in zero-loss
      OrderTakeProfit()+1*Point,            // New value of TakeProfit.
      0,                                    // Deferred order expiration time.
      Aqua);                                // Color of StopLoss and/or TakeProfit modification arrows
      if(VlFl_L!=0)  break;                 // if the fractal is found, exit the loop
      return;
// --- end of 3rd stage ------------------------------------------------------+
      }
     }
    }
   }
  }
 }
//+=======================================================================+
//                 SELL POSITION TRACING:                             +
//+=======================================================================+
  for (i=OrdersTotal()-1; i>=0; i--)      
   {//loop for selection of positions Sell
  if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {Print("Order selection error = ", GetLastError()); }
   if(OrderType()==OP_SELL )                
    { 
//+=======================================================================+
//|  Conditions for closing SELL positions                                    +
//+=======================================================================+
   if(patternBuy==true) 
    { 
    Print(" closing the SELL position as the opposite pattern has emerged");
    Close_S_Ch();         // close the position SELL 
    return;
    }
//+=======================================================================+
//   Conditions for Modification of SELL positions                                    +
// === 1st stage =========================================== 1st stage ===+
   if((OrderOpenPrice()-Bid)>SL_S*Point      
       && OrderStopLoss()>OrderOpenPrice()) 
   if(MdL==0)                                
    {
     OrderModify(OrderTicket(),                // order #. 
     OrderOpenPrice(),                         // opening price. 
     OrderStopLoss()-(SL_S/3*2)*Point,         // New value of StopLoss.
     OrderTakeProfit()-2*Point,                // New value of TakeProfit.
     0,                                        // Deferred order expiration time.
     Aqua);                                    // Color of modification marks (dashes).
     MdL++;
     return;
    }
  // --- end of 1st stage --------------------------------------------------+ 
  // ---- 2nd stage ------------------------------------------------------+
   if((OrderOpenPrice()-Bid)>SL_S*Point      
       && OrderStopLoss()>OrderOpenPrice())  
   if(MdL>=1)
    {
     OrderModify(OrderTicket(),                // order #. 
     OrderOpenPrice(),                         // opening price. 
     OrderStopLoss()-(SL_S+StopLevel)*Point,   // New value of StopLoss - at the zero-loss level
     OrderTakeProfit()-2*Point,                // New value of TakeProfit.
     0,                                        // Deferred order expiration time.
     Aqua);                                    // Color of modification marks (dashes).
     MdL++;
    return;
    }
  // --- end of 2nd stage -------------------------------------------------+ 
  // --- 3rd stage -------------------------------------------------------+
   if((OrderOpenPrice()-Bid)>=(SL_B+SL_B/2)*Point && OrderStopLoss()<=OrderOpenPrice()) 
    {
    for (k=3;k<=12;k++)
     {
     if(High[k]>High[k+1] && High[k]>High[k+2] && High[k]>High[k-1] && High[k]>High[k-2])
      {
      VlFl_H=High[k];           
    if(VlFl_H<OrderStopLoss())  
      {
      timL1_H=iTime(NULL,0,k);  
     OrderModify(OrderTicket(),            // order # 
     OrderOpenPrice(),                     // opening price 
     VlFl_H,                               // New value of StopLoss. // in zero-loss
     OrderTakeProfit()-2*Point,            // New value of TakeProfit.
     0,                                    // Deferred order expiration time.
     Aqua);                                // Color of StopLoss and/or TakeProfit modification arrows
     return;
   if(VlFl_H!=0)  break;     
     }
    }
   }
  }
  // --- end of 3rd stage -------------------------------------------------+ 
  }
 }
//+=======================================================================+
   return(0);
  }//-start
// --- end ---